function RBFGSNonconvexSoftICA(method, paramset, HasHHR, N)

    RBFGSARMIJO = load(['plln_' method 'ARMIJO' num2str(N) '_' num2str(paramset) '_' num2str(HasHHR)]);
    num = size(RBFGSARMIJO, 1);
    ns = size(RBFGSARMIJO, 2)/8;
    RBFGSARMIJO = reshape(RBFGSARMIJO, num, ns, 8);

    tab = zeros(5, 8);

    idx = [1, 2, 3, 5, 8];

    for i = 1 : 5
        if(i ~= 4)
            ave = sum(RBFGSARMIJO(:, :, idx(i))) / num;
        else
            ave = (sum(RBFGSARMIJO(:, :, idx(i))) + sum(RBFGSARMIJO(:, :, 6))) / num;
        end
        tab(i, 1:ns) = ave;
    end

    fout = fopen(['plln_' method 'Nonconvex_ARMIJO_tab_' num2str(N) '_' num2str(paramset) '_' num2str(HasHHR) '.txt'],'w');
    for i = 1 : 5
        for j = 1 : 8

            if(i < 5)
                tabstr = num2str(round(tab(i, j)));
            else
                tabstr = outputfloat(tab(i, j));
            end
            if(j < 8)
                fprintf(fout,['$' tabstr '$ & ']);
            else
                fprintf(fout,['$' tabstr '$']);
            end
        end
        fprintf(fout,' \\\\\n');
    end
    fclose(fout);
end


function str = outputfloat(x)
    if(x <= 0)
        str = '';
        return;
    end
    p = log(x)/log(10);
    p = - ceil(-p);
    x = round(x * 10^(-p) * 100);
    x = x / 100;
    strx = sprintf('%3.2f', x);
    if(p ~= 0)
        str = [strx '_{' num2str(p) '}'];
    else
        str = strx;
    end
end
